#include "strg.h"
#include "init.h"
#include "utis.h"
#include "parser.h"
#include "parser_2.h"

/*
 *  translates book abbreviation from language 'from' to 'to'.
 *
 */


char * trans_abb(char * abb, LANG * from, LANG * to) {
int i;
i=findbook(abb,from); 
return (i==0 ? "???" : booknr(to,i));
 }


/*
 *  Prelozi biblickou citaci z jazyka 'from' do jazyka 'to'.
 *
 *
 */


char * trans_cite(char * cite, LANG * from, LANG * to) {
PARS pp;
int i,
    last=0;
char *ou=NULL;

bcites_pinit(&pp,from);
for(i=0; pp.end!=1 ;i++)
{
 bcites_parser(cite[i],&pp);
 if (pp.ousta>0) 
 {
 switch(pp.ousta)
  {
   case 1:
   case 2:
    if (last==1)  ou=strac(strac(ou,from->chars[0]),' ');  
   case 3:
   case 4:
    if ((last==3) || (last==5) || ((last>=10) && (last<=13)) )
        ou=strac(strac(ou,from->chars[0]),' ');
    break;
   case 5:
   case 6:
    if ((last==10) || (last==11) || (last==13))
       ou=strac(ou,from->chars[2]);
  }     
 switch(pp.ousta)  
  {
  case 1:
  case 2:
   ou=stradd(ou,trans_abb(pp.out,from,to));
   ou=strac(ou,' ');
   break;
  case 5:
  case 6:
   if (last==3) ou=strac(ou,to->chars[3]); 
   if (last==5) ou=strac(ou,to->chars[2]);
  case 3:
  case 4:
   ou=stradd(ou,pp.out);
   break;
  case 11:
   ou=strac(ou,to->chars[5]);
  case 10:
   ou=strac(ou,to->chars[5]);
   break;
  case 12:
   ou=strac(ou,to->chars[4]);
   break;
  case 13:
  case 14:
   ou=stradd(ou,pp.out);
   break;   
 }
switch(pp.ousta)
 {
  case 2:
  case 4:
  case 6:
  case 14:
   ou=stradd(ou,"-");
 }    
 last=pp.ousta;    
 }  
}

return ( pp.errr==1 ? NULL : ou);
}

/*
 *  Expanduje PARS_UNIT
 *
 */

char * bcites_expus (PARS_UNIT ** pp, LANG * l) {
char * ou=NULL;
int first=0,
    i=0;

while (pp[i]!=NULL) 
 {
 if (first) ou=strac(strac(ou,l->chars[0]),' ');
    else first=1; 
 if (pp[i]->cf==0) 
    { 					           /* CHAPF==0 */
      ou=stradd(ou,booknr(l,pp[i]->bf));
    if (pp[i]->b>pp[i]->bf) 
                 ou=stradd(strac(ou,l->chars[1]),booknr(l,pp[i]->b));
    }  
 else if (pp[i]->vf==0)
    {						   /* VERSF==0 */
    ou=strac(stradd(ou,booknr(l,pp[i]->bf)),' ');
    ou=stradd(ou,itoa(pp[i]->cf));
    if (pp[i]->c>pp[i]->cf)
                 ou=stradd(strac(ou,l->chars[1]),itoa(pp[i]->c));
    if (pp[i]->fl==10 || pp[i]->fl==11) ou=strac(ou,l->chars[5]);
    if (pp[i]->fl==11) ou=strac(ou,l->chars[5]);
    if (pp[i]->fl==12) ou=strac(ou,l->chars[4]);
    }
 else 
    {                                             /* full */
    ou=strac(stradd(ou,booknr(l,pp[i]->bf)),' ');
    ou=strac(stradd(ou,itoa(pp[i]->cf)),l->chars[3]);
    ou=stradd(ou,itoa(pp[i]->vf));
    if (pp[i]->abf>'\0') ou=strac(ou,pp[i]->abf);
    if (pp[i]->c>pp[i]->cf)
      {
      ou=stradd(strac(ou,l->chars[1]),itoa(pp[i]->c));
      ou=stradd(strac(ou,l->chars[3]),itoa(pp[i]->v));
      if (pp[i]->ab>'\0') ou=strac(ou,pp[i]->ab);
      }
    else if (pp[i]->v>pp[i]->vf) 
      {
      ou=stradd(strac(ou,l->chars[1]),itoa(pp[i]->v));
      if (pp[i]->ab>'\0') ou=strac(ou,pp[i]->ab);
      }
    if (pp[i]->fl==10 || pp[i]->fl==11) ou=strac(ou,l->chars[5]);
    if (pp[i]->fl==11) ou=strac(ou,l->chars[5]);
    if (pp[i]->fl==12) ou=strac(ou,l->chars[4]);
    }
 i++;   
 }
return  ou;
}



/*
 * Expanze citace : 
 *   -  bcites_expand     = expanze 
 *   -  bcites_expand_bl  = expanze + preklad z jazyka 'from' do 'to'
 *   -  bcites_expand_sort = dtto, ale setridene.
 *
 */

char * bcites_expand (char * cite, LANG * l) {
PARS_UNIT ** pp;
char * out;

pp=makepus(cite,l);
adjpus_n(pp);
adjpus_plus(pp);
adjpus_v01(pp);
out= bcites_expus(pp,l);
freepus (pp);
return out;
}


char * bcites_expand_bl (char * cite, LANG * from, LANG * to) {
PARS_UNIT ** pp;
char * out;

pp=makepus(cite,from);
adjpus_n(pp);
adjpus_plus(pp);
adjpus_v01(pp);
out= bcites_expus(pp,to);
freepus(pp);
return out;
}


char * bcites_expand_sort (char * cite, LANG * from, LANG * to) {
PARS_UNIT ** pp;
char * out;

pp=makepus(cite,from);
adjpus_n(pp);
adjpus_plus(pp);
adjpus_v01(pp);
sortpus(pp);
out= bcites_expus(pp,to);
freepus(pp);
return out;
}

/*
 *  Rozhoduje, zda si odkazy odpovidaji (tj. zda obsahuji alespon 
 *   jednu spolecnou cast textu)
 *
 */



int bcites_is_equal (char *cite1, char * cite2, LANG *l1,LANG *l2) {
PARS_UNIT ** pp1;
PARS_UNIT ** pp2;
int i1,i2,
    ok=0;

pp1=makepus(cite1,l1);
pp2=makepus(cite2,l2);

adjpus_n(pp1);
adjpus_plus(pp1);
adjpus_nn_pseudo(pp1);
adjpus_v01(pp1);

adjpus_n(pp2);
adjpus_plus(pp2);
adjpus_nn_pseudo(pp2);
adjpus_v01(pp2);

for(i1=0; (pp1[i1]!=NULL) && (ok!=1); i1++)
	for(i2=0; (pp2[i2]!=NULL) && (ok!=1); i2++)
	{
		ok|=pu_is_equal(pp1[i1],pp2[i2]);
#ifdef BDEBUG
		printpu(pp1[i1],l1);
		printf(" ? ");
		printpu(pp2[i2],l2);
		printf("  (%d)\n",ok);
#endif
	}
freepus(pp1);
freepus(pp2);
return ok;
}


/*
 *  Porovna odkazy 
 *
 *
 */

int bcites_comp (char *cite1, char * cite2, LANG *l1,LANG *l2) {
PARS_UNIT ** pp1;
PARS_UNIT ** pp2;
int i,
    co=0;

pp1=makepus(cite1,l1);
pp2=makepus(cite2,l2);

adjpus_n(pp1);
adjpus_plus(pp1);
adjpus_nn_pseudo(pp1);
adjpus_v01(pp1);

adjpus_n(pp2);
adjpus_plus(pp2);
adjpus_nn_pseudo(pp2);
adjpus_v01(pp2);


for(i=0; (pp1[i]!=NULL) && (pp2[i]!=NULL) && (co==0); i++)
	co=compare_pu(pp1[i],pp2[i]);

if (co==0)
 {
 if (pp1[i]==NULL && pp2[i]!=NULL) co=1;
 if (pp1[i]!=NULL && pp2[i]==NULL) co=-1;
 }

freepus(pp1);
freepus(pp2);
return co;
}



/*
 *  Test spravnosti zkratky prvni urovne.
 *
 *  (zkouma, zda parser nehlasi nejakou chybu, 
 *    jestli ano, je vystupem pozice chyby +1, jinak 0).
 *
 */

int bcites_check1 (char * cite, LANG * l) {
PARS pp;
int i,r;

bcites_pinit(&pp,l);
for(i=0; pp.end!=1; i++)
 { 
 bcites_parser(cite[i],&pp);
 }
r= pp.errr==1 ? i : 0;
bcites_pfree(&pp);
return r;
}


/*
 *  Test biblickych zkratek :
 *  - vraci ukazatel na prvni chybou zkraktu; jinak NULL  
 *
 *  Predpoklada se, ze jiz byla testovana spravnost prvnim testem
 *                                                    (bcites_check1)
 *
 */


char * bcites_check2 (char * cite, LANG * l) {
PARS pp;
int i;
char * bad=NULL;

bcites_pinit(&pp,l);
for(i=0; (pp.end!=1 && bad==NULL); i++)
 { 
 bcites_parser(cite[i],&pp);
 if (pp.ousta==1 || pp.ousta==2) 
  if (!strcmp(trans_abb(pp.out,l,l),"???")) 
   {
   bad=pp.out;
   pp.out=NULL;
   }
 }
bcites_pfree(&pp);
return bad; 
}

/*
 *  Testuje, zda jsou cisla odkazu 'v mezich normy'
 *
 *    Vystup: NULL (O.K.) nebo spatny retezec
 */

char * bcites_check3 (char * cite, LANG * l) {
PARS pp;
int i;
char * bad=NULL;

bcites_pinit(&pp,l);
for(i=0; (pp.end!=1 && bad==NULL); i++)
 { 
 bcites_parser(cite[i],&pp);
 if (pp.ousta>=3 && pp.ousta<=6)
   if (strlen(pp.out)>3 || pp.out[0]=='\0' ||
       (pp.out[0]=='0' && pp.out[1]=='\0'))
         bad=pp.out;
 }
bcites_pfree(&pp);
return bad; 
}


/*
 * Testuje zda jsou v poradku meze 
 * (Napr. _Gn 1,2-3_ je v poradku, ale _Gn 1,3-2_ ne)
 *  
 *  Vystup : 0= O.K, 1= error
 *
 *   Predpoklada se provedeny test: bcites_check1 az bcites_check3
 */

int bcites_check4(char * cite,LANG *l) {
PPARS pp;
int rt=0;

bcites_ppinit(cite,&pp,l);
for(;pp.end==0;)
{
bcites_pparser(&pp);
if (pp.ou.b>0 && pp.ou.bf>0 && pp.ou.b<pp.ou.bf) rt=1;
if (pp.ou.b==pp.ou.bf &&
    pp.ou.c>0 && pp.ou.cf>0 && pp.ou.c<pp.ou.cf) rt=1;
if (pp.ou.b==pp.ou.bf && pp.ou.c==pp.ou.cf &&
    pp.ou.v>0 && pp.ou.vf>0 && pp.ou.v<pp.ou.vf) rt=1;
}
bcites_ppfree(&pp);
return rt;
} 

/*
 *  Doplnkovy test.
 *
 *  (zkouma, zda ... 
 *    chyba= 1, jinak 0).
 *
 */

int bcites_check9 (char * cite, LANG * l) {
PARS_UNIT ** pp;
int i;
int er=0;

pp=makepus(cite,l);
for(i=0; pp[i]!=NULL && er==0;i++)
 if (pp[i]->c==0 && pp[i]->cf==0) er=1;
freepus(pp);
return er;
}


/*
 *  Debugging section
 *
 */

#ifdef BDEBUG

void main() {
LANG *l;
char s1[100],s2[100];

bcites_init();
bcites_debug=1;
printf("%d\n",bcites_check3("Gn 2,19-1,1",findlang("cz"))); 
printf("%s\n",bcites_expand("Gn 2,19-25.45n.57;2-4;12n;10,12a-11,1b;Ex 2,5nn",findlang("cz"))); 
/*printf("%s\n",bcites_check2("Gn-2 Pa; Ex 4; Dtr 9",findlang("cz")));*/
l=findlang("cz");

printf("\n---\n");

/*printf("\n>>>>%d\n\n",bcites_is_equal("Gn 2,3-25b;ex 22,16; 1s 12,8nn ","Ex 22,17; jon -mt;J 3,16; Gn 2,25b-3,15; 1s 10-20",l,l));
printf("com>%d\n",bcites_comp("J 1-2,3","J 3,19-28",l,l));*/

while (1) 
 {
printf("\n\n1>");readcr(s1,99,stdin); 
printf("2>");readcr(s2,99,stdin);

printf("<%s>&<%s>**>%d\n",s1,s2,bcites_is_equal(s1,s2,l,l));
 }
return 0;
 }

#endif

