#include <stdio.h>  /* for debugging only */
#include "init.h"
#include "parser.h"


/* #define PP2DEB */

typedef struct pars_unit PARS_UNIT;

struct pars_unit
{
int 	b,     /* book */
	c,     /* chapter */
	v,     /* verse */
	fl,    /* flags - such as 'n','nn','+' */

	bf,    /* book-from */
	cf,    /* chapter-from */
	vf,    /* verse-from */
	flf;   /* flags-from */

char 	ab,    /* verse parts ('abcde') */
	abf;   /* verse parts - from */
}; 


typedef struct ppars PPARS;

struct ppars
{
PARS_UNIT in,  /* internal */
	  ou;  /* for output */

int	end,   /* external end status */
	endi,  /* internal status */
	i,     /* index (internal)*/
	lasta; /* the last 'ousta' (internal) */
LANG  * lg;	/* internal */
char * cite;
PARS p;
};

PARS_UNIT * newpu (PARS_UNIT * s)
{
PARS_UNIT * bla;
if ((bla=(PARS_UNIT *)malloc(sizeof(*s)))==NULL)
 {
 printf("Parser_2 (bcites) : can't allocate enought memory !\n");
 exit (1);
 }
memcpy(bla,s,sizeof(*s));
return bla;
} 


void bcites_pu_init(PARS_UNIT * p) {
 p->b=p->c=p->v=p->fl=p->bf=p->cf=p->vf=p->fl=0;
 p->ab=p->abf='\0';
}

void bcites_ppinit(char * cit,PPARS * p, LANG * l) {
 p->lg=l;
 p->lasta=p->endi=p->end=p->i=0;
 p->cite=cit;
 bcites_pu_init(&(p->in));
 bcites_pu_init(&(p->ou));
 bcites_pinit(&(p->p),l); 
 }

void bcites_ppfree(PPARS * p) {
 bcites_pfree(&(p->p));
}

void shipout (PARS_UNIT * dest, PARS_UNIT * src){
dest->b=src->b;
dest->c=src->c;
dest->v=src->v;
dest->fl=src->fl;
dest->ab=src->ab;
dest->bf=src->bf;
dest->cf=src->cf;
dest->vf=src->vf;
dest->flf=src->flf;
dest->abf=src->abf;
src->ab=src->abf=(char)(src->bf=src->cf=src->vf=src->flf=src->fl=0);
}

void adjust (PARS_UNIT * p) {
if (p->bf==0) 
 {
 p->bf=p->b;
 p->cf=p->c;
 p->vf=p->v;
 p->flf=p->fl;
 p->abf=p->ab;
 }
}

int bcites_pparser (PPARS * po) {
int ende=0,
    enen=0, 
    erer=0;

bcites_pu_init(&(po->ou));

if (po->endi)
{
 po->end=1;
 shipout(&(po->ou),&(po->in));
 adjust(&(po->ou));
}
else
{   
 for (; (po->p.end==0 && ende==0) ;po->i++)
 {
 bcites_parser(po->cite[po->i],&(po->p));
#ifdef PP2DEB
 if (po->p.ousta>0) {printf("<%s|",po->p.out);
 printf("\033[31;40m%d\033[37;40;0m>",po->p.ousta);} 
#endif
 if ( (po->p.ousta==1 && (po->lasta==1 || po->lasta==3 || po->lasta==5)) ||
      (po->p.ousta==3 && (po->lasta==3 || po->lasta==5)) ||
      (po->p.ousta==5 &&  po->lasta==5) ||
      (po->p.ousta==2 && (po->lasta==1 || po->lasta==3 || po->lasta==5)) ||
      (po->p.ousta==4 && (po->lasta==3 || po->lasta==5)) ||
      (po->p.ousta==6 &&  po->lasta==5) )
   {
   shipout(&(po->ou),&(po->in));
   adjust(&(po->ou));
   ende=1;
#ifdef PP2DEB   
   printf("{\033[35;40m%d/%d\033[37;40;0m}",po->p.ousta,po->lasta); 
#endif
   }
  else if (po->p.end) enen=1; 

  if (po->p.end) po->endi=1; 
#ifdef PP2DEB
  if (po->p.errr) {ende[A=1; po->end=1; erer=1; printf("<!!>");} 
#endif
  if (po->p.ousta<10 && po->p.ousta>0)  po->lasta=po->p.ousta;

  /* korekce pro "bla 10,5a-..." */
  if (po->lasta==5 && po->p.ousta==14) po->lasta=6;
  switch (po->p.ousta) 
   {
   case 1: po->in.b=findbook(po->p.out,po->lg);
   	   po->in.c=po->in.v=0; 
           break; 
   case 3: po->in.c=atoi(po->p.out);
           po->in.v=0; 
           break; 
   case 5: po->in.v=atoi(po->p.out); 
           break;

   case 2: po->in.bf=findbook(po->p.out,po->lg); 
           break;
   case 4: po->in.cf=atoi(po->p.out);
           po->in.bf=po->in.b;
           po->in.c=po->in.v=0;
           break;
   case 6: po->in.vf=atoi(po->p.out); 
           po->in.bf=po->in.b;
           po->in.cf=po->in.c;
           po->in.v=0;
           break;
   case 10:
   case 11:
   case 12: po->in.fl=po->p.ousta; break;
   case 13: po->in.ab=po->p.out[0]; break;
   case 14: po->in.abf=po->p.out[0];
            po->in.bf=po->in.b;
            po->in.cf=po->in.c;
            po->in.vf=po->in.v;
   }
   if (enen)
   {
   po->end=1;
   shipout(&(po->ou),&(po->in));
   adjust(&(po->ou));
   ende=1;
   }
   
  }
 } 
 return erer;
 }

/*
 * Vytiskne obsah PARS_UNIT
 *
 */

void printpu (PARS_UNIT * pp,LANG *l) {

 printf("%s %d,%d",booknr(l,pp->bf), pp->cf, pp->vf);
 if (pp->flf>9 && pp->flf<13) switch (pp->flf)
  {
 case 10: printf("(%c)",l->chars[5]); break;
 case 11: printf("(%c%c)",l->chars[5],l->chars[5]); break;
 case 12: printf("(%c)",l->chars[4]); break;
  }
 if (pp->abf>'\0') printf("(%c)",pp->abf);
 
 printf(" - %s %d,%d",booknr(l,pp->b), pp->c, pp->v);
 if (pp->fl>9 && pp->fl<13) switch (pp->fl)
  {
 case 10: printf("(%c)",l->chars[5]); break;
 case 11: printf("(%c%c)",l->chars[5],l->chars[5]); break;
 case 12: printf("(%c)",l->chars[4]); break;
  }
 if (pp->ab>'\0') printf("(%c)",pp->ab);
}


/*
 * Vytvori v pameti strukturu  jednotlivych segmentu ....
 *
 */

PARS_UNIT ** makepus (char * cite,LANG * l) {
PPARS pp;
PARS_UNIT ** pt = NULL;
int i,j;
#define SIZEPUS 10

if ((pt=(PARS_UNIT **)malloc(SIZEPUS * sizeof(*pt)))==NULL)
 {
 printf("Parser_2 (bcites) : can't allocate enought memory !\n");
 exit (1);
 }
 
j=SIZEPUS;
bcites_ppinit(cite,&pp,l);
for(i=-1;pp.end==0;)
 {
 bcites_pparser(&pp);
 i++;
 if ((i+1)>j) {
    j+=SIZEPUS;
    if ((pt=(PARS_UNIT **)realloc(pt,j * sizeof(*pt)))==NULL)
     {
     printf("Parser_2 (bcites) : can't allocate enought memory !\n");
     exit (1);
     }
    }  
 pt[i]=newpu(&pp.ou);
 pt[i+1]=NULL;  
 }

bcites_ppfree(&pp); 
return pt;
}

/*
 *  uvolni obsah struktury PARS_UNIT **
 *
 */

void freepus(PARS_UNIT ** pp) {
int i=0;

while (pp[i]!=NULL) {free(pp[i]); i++;};
free(pp);
}


/*
 *  vytiskne obsah struktury PARS_UNIT **
 *
 */

void printpus(PARS_UNIT ** pp,LANG *l) {
int i=0;

while (pp[i]!=NULL) 
 {
 printpu(pp[i],l);
 putchar('\n');
 i++;
 }
}


/*
 *  Upravi citace typu _Gn 1,12n_ na _Gn 1,12-13_
 *
 *
 */

void adjpus_n (PARS_UNIT ** pp) {
int i=0;

while (pp[i]!=NULL)
 {
 if (pp[i]->fl==10) 
  {
  if (pp[i]->vf==0) pp[i]->c++;
               else pp[i]->v++;
  pp[i]->fl=0; pp[i]->flf=0;             
  }
 i++; 
 } 
}

/*
 *  Upravi citace typu _Gn 1,12+_ 
 *
 *
 */

void adjpus_plus (PARS_UNIT ** pp) {
int i=0;

while (pp[i]!=NULL)
 {
 if (pp[i]->fl==12) 
  {
  if (pp[i]->vf==0) pp[i]->c=0;
               else pp[i]->v=0;
  pp[i]->fl=0; pp[i]->flf=0;             
  }
 i++; 
 } 
}

/*
 *   Minimanli-/pseudo- adjustace (pr. Gn 14,5nn -> Gn 14,5-7 )
 *
 */

void adjpus_nn_pseudo (PARS_UNIT ** pp) {
int i=0;

while (pp[i]!=NULL)
 {
 if (pp[i]->fl==11) 
  {
  if (pp[i]->vf==0) pp[i]->c+=2;
               else pp[i]->v+=2;
  pp[i]->fl=0; pp[i]->flf=0;             
  }
 i++; 
 } 
}

/*
 *  Adjustace "Mt 1-2,5" >> "Mt 1,1-2,5"
 *
 */ 
 
void adjpus_v01 (PARS_UNIT ** pp) {
int i=0;

while (pp[i]!=NULL) 
 {
if ((pp[i]->bf>0) /* && (pp[i]->b>0) */
   && (pp[i]->cf>0) && (pp[i]->c>0) && (pp[i]->v>0) && (pp[i]->vf==0)) 
	
   {
    pp[i]->vf=1;
    }
 i++;
 }
}


/*
 *  Porovnani dvou PARS_UNIT na shodu
 *                           --------
 */

#define POROV_MANT(a,b,c,d) (((a<c) && (b>c)) || ((a>c) && (a<d)) || (a==0) || (c==0) || ((b==0) && (d>a)) || ((d==0) && (b>c))) 

/* oprava ^^^^^*/

#define POROV_EQ(a,b,c,d) ((a==b) && (c==d) && (a==c)) 

int pu_is_equal_old (PARS_UNIT * p1, PARS_UNIT * p2) {
int ok=0;

/**/ if (bcites_debug) printf("<b>"); /**/
if POROV_MANT(p1->bf,p1->b,p2->bf,p2->b) ok=1;
else if POROV_EQ(p1->b,p2->bf,p1->bf,p2->b) 
 {
/**/ if (bcites_debug) printf("<c>"); /**/
 if POROV_MANT(p1->cf,p1->c,p2->cf,p2->c) ok=1;
 else if POROV_EQ(p1->c,p2->cf,p1->cf,p2->c)
  {
/**/ if (bcites_debug) printf("<v>"); /**/
  if POROV_MANT(p1->vf,p1->v,p2->vf,p2->v) ok=1;
  else if POROV_EQ (p1->v,p2->vf,p1->vf,p2->v)
   {
 /**/ if (bcites_debug) printf("<a>"); /**/
   if ( ((p1->ab!=0) && (p1->ab>=p2->abf))
          || ((p1->abf!=0) &&(p1->abf>=p2->ab))) ok=1;
   if ((p1->ab==0) || (p1->abf==0)) ok=1;
   }
  else if ((p1->v==p2->vf) || (p1->vf==p2->v)) ok=1;
  }
 else if ((p1->c==p2->cf) || (p1->cf==p2->c)) ok=1;
 }
else if ((p1->b==p2->bf) || (p1->bf==p2->b)) ok=1; 
return ok;
}


int big_eq (int a1,int b1,int c1,int d1,int a2,int b2,int c2,int d2) {
int ok=-1;

if (bcites_debug) printf("([%d %d.%d:%d]?[%d %d.%d:%d]="
		,a1,b1,c1,d1,a2,b2,c2,d2);

#define _BIGE(a,b) if ((a==0)||(b==0)||(a>b)) ok=1; else if (a<b) ok=0;

	_BIGE(a1,a2)
else    _BIGE(b1,b2)
else    _BIGE(c1,c2)
else    _BIGE(d1,d2)
else 	ok=1;
if (bcites_debug) printf ("%d)\n",ok);
return ok;
} 


int pu_is_equal (PARS_UNIT * p1, PARS_UNIT * p2) {
return ((big_eq(p1->b,p1->c,p1->v,p1->ab,p2->b,p2->c,p2->v,p2->ab) &&
         big_eq(p2->b,p2->c,p2->v,p2->ab,p1->bf,p1->cf,p1->vf,p1->abf))
  ||	(big_eq(p2->b,p2->c,p2->v,p2->ab,p1->bf,p1->cf,p1->vf,p1->abf) &&
         big_eq(p1->bf,p1->cf,p1->vf,p1->abf,p2->bf,p2->cf,p2->vf,p2->abf)));


/*  ||	(big_eq(p1->b,p1->c,p1->v,p1->ab,p2->bf,p2->cf,p2->vf,p2->abf) &&
         big_eq(p2->bf,p2->cf,p2->vf,p2->abf,p1->bf,p1->cf,p1->vf,p1->abf))); */

}
/*
 * Porovnani (serazeni) dvou PARS_UNIT
 *
 *  Vraci : 0 (p1'=='p2), 1 (p1'<'p2), -1 (p1'>'p2)
 *
 */

#define BIGR(a,b) if (a!=b) {if (a<b) co=1; else co=-1;}

int compare_pu (PARS_UNIT * p1, PARS_UNIT * p2) {
int co=0;

 BIGR(p1->bf,p2->bf)
else
{    BIGR(p2->b,p1->b)
else
{BIGR(p1->cf,p2->cf)
else
{    BIGR(p2->c,p1->c)
else
{BIGR(p1->vf,p2->vf)
else
{    BIGR(p2->v,p1->v)
else
{BIGR(p1->abf,p2->abf)
else 
     BIGR(p2->ab,p1->ab)
};};};}}}
return co;
}

/*
 *  Sorts 'PARS_UNIT ** pp'
 *
 */

void sortpus( PARS_UNIT ** pp) {
PARS_UNIT * pa;
int i,j;

if ((pp[0]!=NULL) && (pp[1]!=NULL))
 {
 for(i=0;pp[i]!=NULL;i++)
  for(j=0;pp[j]!=NULL;j++)
   if (compare_pu(pp[i],pp[j])>0)
    {
    pa=pp[i];pp[i]=pp[j];pp[j]=pa;
    }
 }
}

#ifdef PPDEBUG
 
int main() {
/* char * hokus="1m1,1-5; jb 3 , 16; f 5n ; ex-dt; pl 1,15-17.19n.28a-40b; 2pa13"; */
char * hokus="ex 44;jon 2";
PPARS pp;
LANG *l;
PARS_UNIT ** pus;
 
 printf("%s\n",hokus); 
 bcites_init();
 l=findlang("cz");

 pus=makepus(hokus,l);
 printpus(pus,l);
 adjpus_n(pus);
 printf("===========\n\033[31;40;1m");
 printpus(pus,l);
 printf("------------\n");
 bcites_ppinit(hokus,&pp,l);
 for(;pp.end==0;)
 {
 bcites_pparser(&pp);
 printf("\t\033[33;40m%s %d,%d[%d/%c]-%s %d,%d[%d/%c]\033[37;40;0m\n", 
         booknr(l,pp.ou.bf), pp.ou.cf, pp.ou.vf, pp.ou.flf, pp.ou.abf,
         booknr(l,pp.ou.b), pp.ou.c, pp.ou.v, pp.ou.fl, pp.ou.ab);        
 }
  
 printf("------------\n");
 bcites_ppinit(hokus,&pp,l);
 for(;pp.end==0;)
 {
 bcites_pparser(&pp);
 printf("\t\033[33;40m%s %d,%d[%d/%c]-%s %d,%d[%d/%c]\033[37;40;0m\n", 
         booknr(l,pp.ou.bf), pp.ou.cf, pp.ou.vf, pp.ou.flf, pp.ou.abf,
         booknr(l,pp.ou.b), pp.ou.c, pp.ou.v, pp.ou.fl, pp.ou.ab);        
 }

return 0; 
}

#endif

