#ifndef BCITES_PARS2_HUU
#define BCITES_PARS2_HUU

typedef struct pars_unit PARS_UNIT;

struct pars_unit
{
int 	b,     /* book */
	c,     /* chapter */
	v,     /* verse */
	fl,    /* flags - such as 'n','nn','+' */

	bf,    /* book-from */
	cf,    /* chapter-from */
	vf,    /* verse-from */
	flf;   /* flags-from */

char 	ab,    /* verse parts ('abcde') */
	abf;   /* verse parts - from */
}; 


typedef struct ppars PPARS;

struct ppars
{
PARS_UNIT in,  /* internal */
	  ou;  /* for output */

int	end,   /* external end status */
	endi,  /* internal status */
	i,     /* index (internal)*/
	lasta; /* the last 'ousta' (internal) */
LANG  * lg;	/* internal */
char * cite;
PARS p;
};

PARS_UNIT * newpu (PARS_UNIT * s);
void bcites_pu_init(PARS_UNIT * p);
void printpu (PARS_UNIT * pp,LANG *l);

void bcites_ppinit(char * cit,PPARS * p, LANG * l);
int bcites_pparser (PPARS * po);
void bcites_ppfree(PPARS * p);

PARS_UNIT ** makepus (char * cite,LANG * l);
void freepus(PARS_UNIT ** pp);
void printpus(PARS_UNIT ** pp,LANG *l);

void adjpus_n (PARS_UNIT ** pp);
void adjpus_plus (PARS_UNIT ** pp);
void adjpus_nn_pseudo (PARS_UNIT ** pp);

void adjpus_v01 (PARS_UNIT *pp);

int pu_is_equal(PARS_UNIT * p1, PARS_UNIT * p2);
int compare_pu (PARS_UNIT * p1, PARS_UNIT * p2);

void sortpus (PARS_UNIT ** pp);

#endif
