#include "bcites.h"
#include "strg.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "sort.h"


LANG *lg1,*lg2,*lgf;

/*
 *  General procedures
 *
 */

char * gttok(char * aa) {
char * bb;
if (!(bb=strtok((char *)aa,"{}")))
 {
 printf("bcindex: Unknown data format !\n");
 exit(-1);
 } 
/* printf("<<%s>>",bb); */
return bb;
}

void gethock(char * aa, char ** cit, char ** nums){
gttok(aa);
*cit=gttok(NULL);
*nums=gttok(NULL);
}

int gettok(FILE * in, char ** cit, char ** nums) {
static char aa[1001];
int i;
i=readcr((char *)aa,1000,in);
if (aa[0]!='\\') return EOF;
gethock((char *)aa,cit,nums);
return i;
}

FILE * fopn(char * jobname, char * suff, char * attr){
char aaa[1000];
FILE * out;
sprintf(aaa,"%s.%s",jobname,suff);
if (!(out=fopen(aaa,attr))) 
   {
   printf("Error opening %s !\n",aaa);
   exit(-1);
   }
return out;
}

/*
 *  1. Expand
 */

void bc_expand (char * jobname) {
FILE * fin, * fout;
char * cit, *expa=NULL,*tok, *nums;

printf("Expanding ...\n");

fin=fopn(jobname,"bct","r");
fout=fopn(jobname,"bce","w");

while (gettok(fin,&cit,&nums)!=EOF) 
 {
/* printf("<=== [%s] (%s)\n",cit,nums); */
 if (expa) free(expa);
 expa=bcites_expand_sort(cit,lg1,lg1);
 if (!strchr(expa,(int)';'))
   {
   fprintf(fout,"\\i{%s}{%s}\n",expa,nums);
   }
 else 
   {  
   tok=strtok(expa,";");
   while (tok)
     {
     fprintf(fout,"\\i{%s}{%s}\n",tok,nums);
     tok=strtok(NULL,";");
     }	
   }
 }
fclose(fin);
fclose(fout);
if (expa) free(expa);
}





/*
 *  2. Sort
 */

int my_compare(char * a, char *b) {
int i,na,nb;
char *a1,*b1,*aa,*bb,*an,*bn;
a1=stradd(NULL,a);
b1=stradd(NULL,b);
gethock(a1,&aa,&an);
gethock(b1,&bb,&bn);
i= bcites_comp(aa,bb,lg1,lg1);

 /* now if cites are equal, compare numbers of lines */
 if (!i)
  {
  na=atoi(an);
  nb=atoi(bn);
  if (nb>na) i=1;
  else if (nb<na) i=-1;
  } 

/* printf("[%s|%s] ? [%s|%s]=%d\n",a,aa,b,bb,i); */
free(a1);
free(b1);
return i;
}

void bc_sort(char *jobname ) {
char aaa[1000];
char bbb[1000];

printf("Sorting ...\n");

sprintf(aaa,"%s.bce",jobname);
sprintf(bbb,"%s.bcs",jobname);

sortt((char *)aaa,"/tmp/abcdef1","/tmp/ghijkl2",(char *)bbb,
      -1,"",(void *)&my_compare);

}





/*
 *   3. 'Compress'
 */

typedef struct page_node PAGE_NODE;

struct page_node{
 int p; /* pageno */
 PAGE_NODE * next;
 };

PAGE_NODE * page_node_new (int p) {
PAGE_NODE * n;

if ((n=(PAGE_NODE *)malloc(sizeof(PAGE_NODE)))==NULL)
 {
 printf("Cannot allocate memory !\n");
 exit(-1);
 }
n->p=p;
n->next=NULL;
return n;
}

void free_page_node_list(PAGE_NODE * list) {
PAGE_NODE * ptr, *now;
ptr=list;
while (ptr)
 {
 now=ptr;
 ptr=ptr->next;
 free(now);
 }
}

void cmp_flush(PAGE_NODE ** start,FILE * out,char *cit) 
{
PAGE_NODE * ptr;
int l=0,mode=0,first=1,d;

fprintf(out,"\\i{%s}{",cit);
ptr=*start;
while(ptr)
 {
 d=(ptr->p)-l;
 if (first) { fprintf(out,"%d",ptr->p); first=0; }
 else if (d>1) { 
                if (mode) { fprintf(out,"%d",l); mode=0; }
		fprintf(out,",%d",ptr->p);
	       }
 else if ((d==1) && (!mode)) { mode=1; fputc('-',out); }
 l=ptr->p;
 ptr=ptr->next;
 }
if (mode) fprintf(out,"%d",l);
fprintf(out,"}\n");
fflush(stdout);
free_page_node_list(*start);
*start=NULL;
}


void bc_compress (char * jobname) {
FILE * fin, * fout;
char * curr, *last=NULL;
char *cit, *nums;
PAGE_NODE * strt=NULL, *end=NULL, *now;

printf("Compressing ...\n");

fin=fopn(jobname,"bcs","r");
fout=fopn(jobname,"bcc","w");

while (gettok(fin,&cit,&nums)!=EOF) 
 {
 /* first of all unify the cite (in order to be able to compare them */
 curr=trans_cite(cit,lg1,lg1);
 if (last) 
    if (strcmp(curr,last)) cmp_flush(&strt,fout,last);	
 /* --- */
 now=page_node_new(atoi(nums));
 if (!strt) strt=now;
 else end->next=now;
 end=now;
 /* --- */
 if (last) free(last);
 last=curr;
 }
cmp_flush(&strt,fout,last);
fclose(fin);
fclose(fout);
}





/*
 * 4. Format
 */

void bc_format (char * jobname) {
FILE * fin, * fout;
char * cit, *nice, *nums;
int bok=-1;
PPARS pp;

printf("Formating ...\n");

fin=fopn(jobname,"bcc","r");
fout=fopn(jobname,"bci","w");

while (gettok(fin,&cit,&nums)!=EOF) 
 {
 bcites_ppinit(cit,&pp,lg1);
 bcites_pparser(&pp);
 if (bok!=pp.ou.bf) { 
       bok=pp.ou.bf; 
       fprintf(fout,"\n\\bcbookname{%s}\n\n",booknr(lgf,pp.ou.bf));
                    }
 bcites_ppfree(&pp);
 nice=trans_cite(cit,lg1,lg2);
 fprintf(fout,"\\bcitem{%s}{%s}\n",nice,nums);
 free(nice);
 }
fclose(fin);
fclose(fout);
}



/*
 *
 *
 *  Main program
 *
 *
 */

void inval(void) 
 {
 printf("USAGE: bcindex jobname [step]\n"
        ",where <step> can be 	\'1\' .. for expanding (.bct -> .bce)\n"
	"			\'2\' .. for sorting (.bce -> .bcs)\n"
	"			\'4\' .. for compressing (.bcs -> .bcc)\n"
	"			\'8\' .. for formating (.bcc -> .bci)\n"
	"  			\'all\' .. for all (.bct -> .bci)\n\n");
 exit(-1);
 }

#define ALL 15

int main (int argc, char ** argv ) {
int step;

if ((argc<2) || (argc>3)) inval();
if (argc==3)
{
if (!(strcmp(argv[2],"all"))) step=ALL;
else step=atoi(argv[2]);
}
else step=ALL;
if ((!step) || (step==5) || (step==9) || (step==10)) inval();

bcites_init();
lg1=findlang("cz");

if (step&1) bc_expand((char *)argv[1]);
if (step&2) bc_sort((char *)argv[1]);
if (step&4) bc_compress((char *)argv[1]);

lg2=findlang("cz-il2");
lgf=findlang("cz-full-il2");
if (step&8) bc_format((char *)argv[1]);

return 0;
}
